/**
 * @license
 *-------------------------------------------------------------------------------------------
 * Copyright © 2025 Progress Software Corporation. All rights reserved.
 * Licensed under commercial license. See LICENSE.md in the package root for more information
 *-------------------------------------------------------------------------------------------
 */
import * as o from "react";
import e from "prop-types";
import { Popup as Je } from "@progress/kendo-react-popup";
import { cloneDate as ne, getDate as Qe } from "@progress/kendo-date-math";
import { validatePackage as et, useId as tt, useAdaptiveModeContext as nt, usePropsContext as ot, canUseDOM as oe, AsyncFocusBlur as rt, classNames as re, kendoThemeMaps as ae, createPropsContext as at, Keys as O } from "@progress/kendo-react-common";
import { calendarIcon as lt } from "@progress/kendo-svg-icons";
import { packageMetadata as ut } from "../package-metadata.mjs";
import { DateInput as it } from "../dateinput/DateInput.mjs";
import { Calendar as st } from "../calendar/components/Calendar.mjs";
import { nullable as a, MAX_DATE as ct, MIN_DATE as dt, isInDateRange as ft, setTime as mt } from "../utils.mjs";
import { toggleCalendar as le, messages as pt } from "../messages/index.mjs";
import { useLocalization as gt } from "@progress/kendo-react-intl";
import { ToggleButton as ht } from "./ToggleButton.mjs";
import { PickerWrap as vt } from "../common/PickerWrap.mjs";
import { PickerFloatingLabel as wt } from "../hooks/usePickerFloatingLabel.mjs";
import { ActionSheetContent as bt } from "@progress/kendo-react-layout";
import { AdaptiveMode as yt } from "../common/AdaptiveMode.mjs";
const ue = o.forwardRef((n, ie) => {
  et(ut);
  const F = tt(n.id), se = gt(), g = nt(), {
    defaultShow: ce = l.defaultShow,
    defaultValue: de = l.defaultValue,
    dateInput: fe = l.dateInput,
    calendar: me = l.calendar,
    toggleButton: pe = l.toggleButton,
    popup: ge = l.popup,
    pickerWrap: kt = l.pickerWrap,
    disabled: h = l.disabled,
    format: he = l.format,
    max: R = l.max,
    min: I = l.min,
    popupSettings: v = l.popupSettings,
    tabIndex: ve = l.tabIndex,
    weekNumber: we = l.weekNumber,
    validityStyles: N = l.validityStyles,
    size: S = l.size,
    rounded: E = l.rounded,
    fillMode: x = l.fillMode,
    autoFocus: be = l.autoFocus,
    show: z,
    autoSwitchParts: ye,
    autoSwitchKeys: Ce,
    twoDigitYearMax: ke,
    ariaLabel: De,
    adaptive: Dt,
    adaptiveTitle: Oe,
    inputAttributes: Me,
    validationMessage: W,
    _adaptiveMode: Ot = g,
    valid: L,
    focusedDate: Pe,
    ...K
  } = ot(Ct, n), B = () => {
    if (oe)
      return b.current && b.current.ownerDocument || window.document;
  }, s = () => !!(p.windowWidth && g && p.windowWidth <= (g == null ? void 0 : g.medium) && n.adaptive), d = () => {
    const t = C.current !== void 0 && C.current !== null ? C.current : n.value !== void 0 ? n.value : p.value;
    return t !== null ? ne(t) : null;
  }, u = () => M.current !== void 0 ? M.current : z !== void 0 ? z : p.show, Re = () => fe || l.dateInput, Ie = () => pe || l.toggleButton, Se = () => me || l.calendar, Ee = () => ge || l.popup, q = () => n.required !== void 0 ? n.required : !1, T = () => {
    const t = d() || n.value || null, r = I, i = R, P = ft(t, r, i), _ = W !== void 0, A = (!q() || t != null) && P, V = L !== void 0 ? L : A;
    return {
      customError: _,
      rangeOverflow: t && i.getTime() < t.getTime() || !1,
      rangeUnderflow: t && t.getTime() < r.getTime() || !1,
      valid: V,
      valueMissing: t === null
    };
  }, xe = (t) => {
    for (const r of t)
      D({ windowWidth: r.target.clientWidth });
  }, Be = () => {
    c.current && c.current.focus();
  }, H = (t) => {
    y.current = t;
  }, f = (t) => {
    u() !== t && (D({ show: t }), t && n.onOpen && n.onOpen.call(void 0, { target: w.current }), !t && n.onClose && n.onClose.call(void 0, { target: w.current }));
  }, Te = (t) => {
    const r = d();
    return r && t ? mt(t, r) : t;
  }, _e = (t) => {
    v != null && v.onMouseDownOutside && v.onMouseDownOutside.call(void 0, t);
  }, U = (t, r) => {
    D({ value: ne(t || void 0) }), C.current = t, M.current = !1, s() || (m.current = !0), n.onChange && n.onChange.call(void 0, {
      syntheticEvent: r.syntheticEvent,
      nativeEvent: r.nativeEvent,
      value: d(),
      show: u(),
      target: w.current
    }), C.current = void 0, M.current = void 0, f(!1);
  }, Ae = (t) => {
    const r = Te(t.value);
    U(r, t);
  }, Y = () => {
    const { popupClass: t, ...r } = v, i = u(), P = d(), _ = P && Qe(P), A = re(t), V = {
      popupClass: "k-datepicker-popup",
      show: i,
      anchor: b.current,
      className: A,
      id: Z,
      anchorAlign: {
        horizontal: "left",
        vertical: "bottom"
      },
      popupAlign: {
        horizontal: "left",
        vertical: "top"
      },
      ...r,
      onMouseDownOutside: _e
    }, ee = {
      disabled: h,
      value: _,
      min: I,
      max: R,
      weekNumber: we,
      focusedDate: Pe,
      className: s() ? "k-calendar-lg" : "",
      navigation: !s(),
      onChange: Ae
    }, te = Se(), Ge = Ee();
    return s() ? /* @__PURE__ */ o.createElement(te, { _ref: H, ...ee }) : /* @__PURE__ */ o.createElement(Ge, { ...V }, /* @__PURE__ */ o.createElement(te, { _ref: H, ...ee }));
  }, $ = () => {
    D({ focused: !1 }), f(!1);
  }, Ve = () => {
    const { windowWidth: t = 0 } = p, r = {
      expand: u(),
      onClose: $,
      adaptiveTitle: Oe,
      windowWidth: t
    }, i = Y();
    return /* @__PURE__ */ o.createElement(yt, { ...r }, /* @__PURE__ */ o.createElement(bt, { overflowHidden: !0 }, i));
  }, Fe = (t) => {
    U(t.value, t);
  }, Ne = () => {
    D({ focused: !0 });
  }, ze = () => {
    f(!u());
  }, j = () => {
    h || (m.current = !0, f(!u()));
  }, We = (t) => {
    t.preventDefault();
  }, Le = (t) => {
    const { altKey: r, keyCode: i } = t;
    if (i === O.esc && u()) {
      m.current = !0, f(!1);
      return;
    }
    r && (i === O.up || i === O.down) && (t.preventDefault(), t.stopPropagation(), m.current = i === O.up, f(i === O.down));
  }, w = o.useRef(null), b = o.useRef(null), c = o.useRef(null), y = o.useRef(null);
  o.useImperativeHandle(
    w,
    () => ({
      props: n,
      get element() {
        return b.current;
      },
      get calendar() {
        return y.current;
      },
      get dateInput() {
        return c.current;
      },
      get name() {
        return n.name;
      },
      get show() {
        return u();
      },
      get validity() {
        return T();
      },
      get value() {
        return d();
      },
      get mobileMode() {
        return s();
      },
      togglePopup: ze,
      // Hidden Methods but still accessible
      focus: Be
    })
  ), o.useImperativeHandle(ie, () => w.current);
  const C = o.useRef(null), M = o.useRef(void 0), Ke = o.useRef(null), m = o.useRef(!1), X = o.useRef(!1), k = o.useRef(null), [p, qe] = o.useState({
    value: de,
    show: ce,
    focused: !1
  }), [, He] = o.useReducer((t) => t, !0), D = (t) => {
    qe((r) => ({ ...r, ...t }));
  };
  o.useEffect(() => {
    y.current && y.current.element && u() && !X.current && y.current.element.focus({ preventScroll: !0 }), c.current && c.current.element && !u() && m.current && c.current.element.focus({ preventScroll: !0 }), X.current = u(), m.current = !1;
  }), o.useEffect(() => {
    var t;
    return k.current = oe && window.ResizeObserver && new window.ResizeObserver((r) => xe(r)), u() && He(), (t = B()) != null && t.body && k.current && k.current.observe(B().body), () => {
      var r;
      clearTimeout(Ke.current), (r = B()) != null && r.body && k.current && k.current.disconnect();
    };
  }, []);
  const Z = F + "-popup-id", Ue = Y(), Ye = Re(), $e = d(), je = Ie(), Xe = Ve(), G = !N || T().valid, J = se.toLanguageString(le, pt[le]), Ze = {
    disabled: h,
    format: he,
    formatPlaceholder: n.formatPlaceholder,
    id: n.id,
    ariaLabelledBy: n.ariaLabelledBy,
    ariaDescribedBy: n.ariaDescribedBy,
    ariaLabel: De,
    max: R,
    min: I,
    name: n.name,
    onChange: Fe,
    required: n.required,
    _ref: c,
    tabIndex: u() ? -1 : ve,
    title: n.title,
    valid: T().valid,
    validationMessage: W,
    validityStyles: N,
    value: $e,
    label: void 0,
    placeholder: p.focused ? null : n.placeholder,
    ariaExpanded: u(),
    size: null,
    fillMode: null,
    rounded: null,
    autoFill: n.autoFill,
    twoDigitYearMax: ke,
    enableMouseWheel: n.enableMouseWheel,
    autoCorrectParts: n.autoCorrectParts,
    autoSwitchParts: ye,
    autoSwitchKeys: Ce,
    allowCaretMode: n.allowCaretMode,
    inputAttributes: Me
  }, Q = /* @__PURE__ */ o.createElement(
    rt,
    {
      onFocus: Ne,
      onBlur: s() ? void 0 : $,
      onSyncBlur: n.onBlur,
      onSyncFocus: n.onFocus
    },
    (t) => /* @__PURE__ */ o.createElement(o.Fragment, null, /* @__PURE__ */ o.createElement(
      "span",
      {
        ...n.label ? {} : K,
        ref: b,
        className: re(
          "k-input",
          "k-datepicker",
          {
            [`k-input-${ae.sizeMap[S] || S}`]: S,
            [`k-rounded-${ae.roundedMap[E] || E}`]: E,
            [`k-input-${x}`]: x,
            "k-invalid": !G,
            "k-required": q(),
            "k-disabled": h
          },
          n.className
        ),
        onKeyDown: Le,
        style: { width: n.width },
        onFocus: t.onFocus,
        onBlur: t.onBlur,
        onClick: s() ? j : void 0
      },
      /* @__PURE__ */ o.createElement(
        Ye,
        {
          _ref: c,
          ariaRole: "combobox",
          ariaExpanded: u(),
          ariaControls: Z,
          autoFocus: be,
          ...Ze
        }
      ),
      /* @__PURE__ */ o.createElement(
        je,
        {
          type: "button",
          icon: "calendar",
          svgIcon: lt,
          title: J,
          className: "k-input-button",
          rounded: null,
          onClick: s() ? void 0 : j,
          "aria-label": J,
          fillMode: x,
          onMouseDown: We
        }
      ),
      !s() && Ue
    ), s() && Xe)
  );
  return n.label ? /* @__PURE__ */ o.createElement(
    wt,
    {
      dateInput: c,
      label: n.label,
      editorId: F,
      editorValid: G,
      editorDisabled: h,
      children: Q,
      style: { width: n.width },
      ...K
    }
  ) : Q;
});
ue.propTypes = {
  className: e.string,
  defaultShow: e.bool,
  defaultValue: e.instanceOf(Date),
  disabled: e.bool,
  focusedDate: e.instanceOf(Date),
  format: e.oneOfType([
    e.string,
    e.shape({
      skeleton: a(e.string),
      pattern: a(e.string),
      date: a(e.oneOf(["short", "medium", "long", "full"])),
      time: a(e.oneOf(["short", "medium", "long", "full"])),
      datetime: a(e.oneOf(["short", "medium", "long", "full"])),
      era: a(e.oneOf(["narrow", "short", "long"])),
      year: a(e.oneOf(["numeric", "2-digit"])),
      month: a(e.oneOf(["numeric", "2-digit", "narrow", "short", "long"])),
      day: a(e.oneOf(["numeric", "2-digit"])),
      weekday: a(e.oneOf(["narrow", "short", "long"])),
      hour: a(e.oneOf(["numeric", "2-digit"])),
      hour12: a(e.bool),
      minute: a(e.oneOf(["numeric", "2-digit"])),
      second: a(e.oneOf(["numeric", "2-digit"])),
      timeZoneName: a(e.oneOf(["short", "long"]))
    })
  ]),
  formatPlaceholder: e.oneOfType([
    a(e.oneOf(["wide", "narrow", "short", "formatPattern"])),
    e.shape({
      year: a(e.string),
      month: a(e.string),
      day: a(e.string),
      hour: a(e.string),
      minute: a(e.string),
      second: a(e.string)
    })
  ]),
  id: e.string,
  ariaLabelledBy: e.string,
  ariaDescribedBy: e.string,
  ariaLabel: e.string,
  min: e.instanceOf(Date),
  max: e.instanceOf(Date),
  name: e.string,
  popupSettings: e.shape({
    animate: a(e.bool),
    appendTo: a(e.any),
    popupClass: a(e.string)
  }),
  show: e.bool,
  tabIndex: e.number,
  title: e.string,
  value: e.instanceOf(Date),
  weekNumber: e.bool,
  width: e.oneOfType([e.number, e.string]),
  validationMessage: e.string,
  required: e.bool,
  valid: e.bool,
  size: e.oneOf([null, "small", "medium", "large"]),
  rounded: e.oneOf([null, "small", "medium", "large", "full"]),
  fillMode: e.oneOf([null, "solid", "flat", "outline"]),
  adaptive: e.bool,
  adaptiveTitle: e.string,
  autoFocus: e.bool,
  inputAttributes: e.object
};
const l = {
  defaultShow: !1,
  defaultValue: null,
  dateInput: it,
  calendar: st,
  toggleButton: ht,
  popup: Je,
  pickerWrap: vt,
  disabled: !1,
  format: "d",
  max: ct,
  min: dt,
  popupSettings: {},
  tabIndex: 0,
  weekNumber: !1,
  validityStyles: !0,
  size: "medium",
  rounded: "medium",
  fillMode: "solid",
  autoFocus: !1
}, Ct = at();
ue.displayName = "KendoReactDatePicker";
export {
  ue as DatePicker,
  Ct as DatePickerPropsContext,
  l as datePickerDefaultProps
};
